diff -r 18e7ae2455ca nuxeo-platform-lang/src/main/resources/nuxeo.war/WEB-INF/classes/messages_en.properties
--- a/nuxeo-platform-lang/src/main/resources/nuxeo.war/WEB-INF/classes/messages_en.properties	Mon Mar 30 00:01:11 2009 +0200
+++ b/nuxeo-platform-lang/src/main/resources/nuxeo.war/WEB-INF/classes/messages_en.properties	Tue Mar 31 09:03:08 2009 +0200
@@ -162,7 +162,7 @@
 command.logout=Log out
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/resources/OSGI-INF/actions-contrib.xml
-command.manageMembers=Members management
+command.manageMembers=Member management
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/resources/OSGI-INF/actions-contrib.xml
 command.mass_edition.addworklist=Edit documents
@@ -194,7 +194,7 @@
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/view_vocabularies.xhtml
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/resources/OSGI-INF/actions-contrib.xml
-title.vocabularies=Vocabularies management
+title.vocabularies=Vocabulary management
 
 #
 # General
@@ -438,10 +438,10 @@
 label.forum.content.header.moderated=Moderation
 
 #: nuxeo-platform/nuxeo-platform-forum/src/main/resources/nuxeo.war/incl/forum_table.xhtml
-label.forum.content.header.nb_pending_posts=Nb. of pending posts
-
-#: nuxeo-platform/nuxeo-platform-forum/src/main/resources/nuxeo.war/incl/forum_table.xhtml
-label.forum.content.header.nb_published_posts=Nb. of published posts
+label.forum.content.header.nb_pending_posts=Nbr. of pending posts
+
+#: nuxeo-platform/nuxeo-platform-forum/src/main/resources/nuxeo.war/incl/forum_table.xhtml
+label.forum.content.header.nb_published_posts=Nbr. of published posts
 
 #: nuxeo-platform/nuxeo-platform-forum/src/main/resources/nuxeo.war/incl/forum_table.xhtml
 label.forum.content.header.thread=Topic
@@ -675,7 +675,7 @@
 label.relation.deleted=Relation deleted
 
 #: nuxeo-platform/nuxeo-platform-relations-web/src/main/resources/nuxeo.war/incl/tabs/document_relations.xhtml
-label.relation.noRelation=No incoming nor outgoing relation for this document
+label.relation.noRelation=No incoming or outgoing relation for this document
 
 # for notification logs
 
@@ -840,7 +840,7 @@
 command.goHome=Home
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/resources/OSGI-INF/actions-contrib.xml
-command.manageThemes=Themes management
+command.manageThemes=Theme management
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/massedit_documents.xhtml
 command.next=Next
@@ -1084,9 +1084,6 @@
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_workspaces.xhtml
 title.dashboard.userWorkspaces=My workspaces
-
-#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_sites.xhtml
-title.dashboard.userSites=My sites
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_last_documents.xhtml
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/view_workspaces.xhtml
@@ -1233,10 +1230,10 @@
 label.security.localRights=Local rights
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/tabs/document_rights.xhtml
-label.security.noParentDocumentsRights=No right is inherited from parent documents
-
-#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/tabs/document_rights.xhtml
-label.security.noLocalRights=No local right is defined on the current document
+label.security.noParentDocumentsRights=No rights are inherited from parent documents
+
+#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/tabs/document_rights.xhtml
+label.security.noLocalRights=No local rights are defined on the current document
 
 # Really used (see labeller in PermissionActionListManager.java)
 label.security.grant=Grant
@@ -1297,7 +1294,7 @@
 label.search.results.nxql=Search results for NXQL:
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/search/search_form.xhtml
-label.search.administrate=Administrate the search service
+label.search.administrate=Administer the search service
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/search/search_admin.xhtml
 label.search.reindex=Reindex all
@@ -1524,7 +1521,7 @@
 error.required=Value required.
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/tabs/document_files_view.xhtml
-label.files.noAttachedFiles=There are no attached files to this document.
+label.files.noAttachedFiles=There are no files attached to this document.
 
 # Labels for document types
 #: nuxeo-platform/nuxeo-platform-comment-web/src/main/resources/OSGI-INF/comment-types-contrib.xml
@@ -1841,7 +1838,7 @@
 
 #: nuxeo-platform/nuxeo-platform-publishing-web/src/main/java/org/nuxeo/ecm/platform/publishing/PublishActionsBean.java
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/security/MassSecurityModifierActions.java
-selection_contains_non_publishable_docs=Your selection contains non publishable documents
+selection_contains_non_publishable_docs=Your selection contains unpublishable documents
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/contentbrowser/DocumentActionsBean.java
 document_modified={0} modified
@@ -1852,7 +1849,7 @@
 document_saved={0} saved
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/action/DeleteActionsBean.java
-can_not_delete_proxies=Documents cannot be deleted, but unpublished.
+can_not_delete_proxies=Documents cannot be deleted, but can be unpublished.
 
 # documents updated message used by bulk editing feature
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/bulkupdate/MassEditActionsBean.java
@@ -2084,7 +2081,7 @@
 document.lock=Document locked
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/edit/lock/LockActionsBean.java
-document.lock.failed=Document lock failed! Another user probably took the lock of this document during this time or a workflow was started in the meanwhile.
+document.lock.failed=Document lock failed! Another user may have locked the document or a workflow may have been started.
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/edit/lock/LockActionsBean.java
 document.unlock=Document unlocked
@@ -2361,10 +2358,10 @@
 title.dashboard.userProcesses=My workflows
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_processes.xhtml
-label.dashboard.user.document.process.empty=Currently, you don't manage any running workflow
-
-#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_processes.xhtml
-label.user.processes=Below are listed the workflows you are currently managing
+label.dashboard.user.document.process.empty=You don't currently manage any running workflows
+
+#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_processes.xhtml
+label.user.processes=The workflows you are currently managing are listed below
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/editor_image_upload.xhtml
 title.imageUpload.form=Insert an image
@@ -2423,7 +2420,7 @@
 label.workflow.activeWorkflows=Active workflows
 label.workflow.assignTask=Assign to
 label.workflow.completeTask=Terminate task
-label.workflow.noProcesses=This document is not part of any workflows for the moment
+label.workflow.noProcesses=This document is not currently part of any workflow
 label.workflow.processesTitle=Workflows
 label.workflow.select=Selection
 label.workflow.selectProcessInstanceToDelete=Select one or several workflows above
@@ -2437,7 +2434,7 @@
 label.browse.back=Back
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_tasks.xhtml
-label.dashboard.empty=Your dashboard is empty. There is no task that requires your intervention.
+label.dashboard.empty=Your dashboard is empty. There are no tasks that require your intervention.
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/java/org/nuxeo/ecm/platform/workflow/web/listener/ejb/DocumentTaskActionsBean.java
 label.log.comment.assignedToGroup=Assigned to group
@@ -2469,7 +2466,7 @@
 label.review.end.task=Approve
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/resources/nuxeo.war/incl/document_review_start_form.xhtml
-label.review.fillup.information=Please, fill up the workflow property form below
+label.review.fillup.information=Please fill out the workflow property form below
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/resources/nuxeo.war/incl/document_review_members_management.xhtml
 label.review.insertionLevel=Insertion level
@@ -2488,7 +2485,7 @@
 label.review.my.tasks=Abandon workflow
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/resources/nuxeo.war/incl/document_review_start_form.xhtml
-label.review.no.review.started=No workflows are currently active on this document. You are not granted for starting one.
+label.review.no.review.started=No workflows are currently active for this document. You don't have the rights to start a workflow.
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/resources/nuxeo.war/incl/document_review_start_form.xhtml
 label.review.out.life.cycle=Destination lifecycle after workflow
@@ -2627,7 +2624,7 @@
 label.workflow.task.validated=Approved
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/incl/dashboard_user_tasks.xhtml
-label.workflow.tasks=The table below shows you all the tasks on which you have been requested to perform an operation.
+label.workflow.tasks=The table below shows all the tasks for which you have been requested to perform an operation.
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/java/org/nuxeo/ecm/platform/workflow/web/listener/ejb/WorkItemsListsActionsBean.java
 label.workflow.workitem.lists.duplicate.name=List already exists. Please enter another name.
@@ -2760,7 +2757,7 @@
 #: nuxeo-platform/nuxeo-platform-notification-core/src/main/resources/templates/workflow.ftl
 #: nuxeo-platform/nuxeo-platform-workflow-api/src/main/java/org/nuxeo/ecm/platform/workflow/api/common/WorkflowEventTypes.java
 #: nuxeo-platform/nuxeo-platform-workflow-core/src/main/resources/OSGI-INF/nxaudit-events-workflow.xml
-workflowAbandoned=Workflow Abandoned
+workflowAbandoned=Workflow abandonned
 
 #: nuxeo-platform/nuxeo-platform-workflow-client/src/main/resources/nuxeo.war/incl/document_review_start_form.xhtml
 #: nuxeo-platform/nuxeo-platform-workflow-document-api/src/main/java/org/nuxeo/ecm/platform/workflow/document/api/WorkflowDocumentModificationConstants.java
@@ -2811,7 +2808,7 @@
 command.dynsearch.clear=Reset
 command.dynsearch.create=Create
 command.dynsearch.field.add=Add
-command.dynsearch.link=Dynamical search
+command.dynsearch.link=Dynamic search
 command.dynsearch.moveDown=Move down
 command.dynsearch.moveFirst=Move first
 command.dynsearch.moveLast=Move last
@@ -2833,8 +2830,8 @@
 label.dynsearch.parenthesis.close=Close parenthesis
 label.dynsearch.parenthesis.open=Inside a new parenthesis
 title.dynsearch.availablefields=Available Fields
-title.dynsearch.create=New saved dynamical search
-title.dynsearch.form=Dynamical search
+title.dynsearch.create=New saved dynamic search
+title.dynsearch.form=Dynamic search
 title.dynsearch.query=Query editor
 title.dynsearch.results=Results display options
 title.dynsearch.selectedfields=Selected Fields
@@ -2865,7 +2862,7 @@
 label.picture.subheadline=SubHeadline
 label.picture.timeinterval=Time Interval
 label.picture.typage=Typage
-label.picture.upload.error=This Picture format is currently not supported.
+label.picture.upload.error=This Picture format is not currently supported.
 label.picture.upload=Upload
 label.picture.views=Views
 title.create.picture=Create a Picture
@@ -3895,9 +3892,6 @@
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/login.jsp
 label.login.joinTheCommunity=Join the community
 
-#: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/login.jsp
-label.login.quickStart=QuickStart
-
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/login-5-1.jsp
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/login.jsp
 label.login.welcomeToNuxeoEnterprise=Welcome to Nuxeo Enterprise Platform 5.2
@@ -3934,7 +3928,7 @@
 Error.Document.Not.Found=Document does not exist
 
 #: nuxeo-platform/nuxeo-platform-web-common/src/main/resources/OSGI-INF/exception-handling-contrib.xml
-Error.Insuffisant.Rights=You don't have sufficient rights to do this operation
+Error.Insuffisant.Rights=You don't have sufficient rights to perform this operation
 
 #: nuxeo-platform/nuxeo-platform-web-common/src/main/resources/OSGI-INF/exception-handling-contrib.xml
 Error.Unknown=an unexpected error occured
@@ -4082,13 +4076,13 @@
 label.groupManager.viewGroup=View
 
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/security/GroupManagerActionsBean.java
-label.groupManager.wrongGroupName=Group name must contain only alpha-numeric characters !
+label.groupManager.wrongGroupName=Group name must contain only alphanumeric characters!
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/mail_template.xhtml
 label.mail.after.document.link=.
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/mail_template.xhtml
-label.mail.before.document.link=You can acces the document by clicking
+label.mail.before.document.link=You can access the document by clicking
 
 #: nuxeo-platform/nuxeo-platform-webapp/src/main/resources/nuxeo.war/mail_template.xhtml
 label.mail.document.link=here
@@ -4221,7 +4215,7 @@
 #: nuxeo-platform/nuxeo-platform-webapp-core/src/main/java/org/nuxeo/ecm/webapp/edit/vocabularies/VocabularyActionsBean.java
 vocabulary.entry.any.selectitem=
 
-action.admin.publication.tree=Administrate publication trees
+action.admin.publication.tree=Administer publication trees
 
 label.publish.add.section=Add
 label.publish.publish=Publish here
@@ -4236,6 +4230,7 @@
 
 workflowNewProcessStarted=New Workflow started
 workflowProcessEnded=Workflow ended
+workflowAbandoned=Workflow Abandoned
 workflowTaskCompleted=Workflow task completed
 label.review.lifecycle.noChange=Unchanged
 label.workflow.task.choose-participant=Choose the reviewers
@@ -4257,6 +4252,6 @@
 label.review.task.enterComment=Please enter a comment before rejection
 
 # label for PDF conversions information popup
-label.pdf.openOffice.setup=more informations about OOo setup
+label.pdf.openOffice.setup=more information about OOo setup
 label.pdf.openOffice.error=native error while communicating with OOo server
 label.pdf.openOffice.refresh=re-test OOo server