diff -r d9b98ba020a1 nuxeo-studio-app/pom.xml
--- a/nuxeo-studio-app/pom.xml	Wed Oct 19 21:08:04 2011 +0200
+++ b/nuxeo-studio-app/pom.xml	Thu Nov 17 14:35:04 2011 +0100
@@ -19,12 +19,27 @@
   </description>
 
   <properties>
-    <gwt.module>org.nuxeo.studio.StudioApp</gwt.module>
   </properties>
 
   <dependencies>
     <dependency>
       <groupId>org.nuxeo.studio</groupId>
+      <artifactId>nuxeo-gwt-ui-base</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.studio</groupId>
+      <artifactId>nuxeo-gwt-boxes</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.studio</groupId>
+      <artifactId>nuxeo-studio-git</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.studio</groupId>
+      <artifactId>nuxeo-gwt-diagrams</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.studio</groupId>
       <artifactId>nuxeo-studio-ui</artifactId>
     </dependency>
     <dependency>
@@ -36,9 +51,24 @@
       <artifactId>gwt-user</artifactId>
     </dependency>
     <dependency>
-      <groupId>com.google.gwt</groupId>
-      <artifactId>gwt-dev</artifactId>
-      <optional>true</optional>
+      <groupId>org.nuxeo.ecm.platform</groupId>
+      <artifactId>nuxeo-platform-forms-layout-api</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.ecm.automation</groupId>
+      <artifactId>nuxeo-automation-core</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>org.nuxeo.ecm.webengine</groupId>
+      <artifactId>nuxeo-webengine-core</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>net.zschech</groupId>
+      <artifactId>gwt-comet</artifactId>
+    </dependency>
+    <dependency>
+      <groupId>com.thoughtworks.xstream</groupId>
+      <artifactId>xstream</artifactId>
     </dependency>
     <dependency>
       <groupId>org.nuxeo.build</groupId>
@@ -64,15 +94,6 @@
 
 
   <build>
-    <!-- gwt compiler needs the java sources to correctly work -->
-    <resources>
-      <resource>
-        <directory>src/main/java</directory>
-      </resource>
-      <resource>
-        <directory>src/main/resources</directory>
-      </resource>
-    </resources>
 
     <plugins>
       <!-- correctly generate eclipse files with GWT nature -->
@@ -88,9 +109,7 @@
           <downloadSources>false</downloadSources>
           <additionalProjectnatures>
             <projectnature>com.google.gwt.eclipse.core.gwtNature</projectnature>
-            <projectnature>
-              com.google.gdt.eclipse.core.webAppNature
-            </projectnature>
+            <projectnature>com.google.gdt.eclipse.core.webAppNature</projectnature>
           </additionalProjectnatures>
           <additionalBuildcommands>
             <buildCommand>
@@ -111,54 +130,26 @@
           <buildOutputDirectory>war/WEB-INF/classes</buildOutputDirectory>
         </configuration>
       </plugin>
-      <!--
-        After compiling java sources compile java to JS using GWT compiler. This
-        must be done process-classes after compile step finished to be sure we
-        have all the needed files in classes directory. I am using ant for this
-        since the maven exec plugin is not able to run correctly this
-      -->
+      <plugin>
+        <groupId>org.codehaus.mojo</groupId>
+        <artifactId>gwt-maven-plugin</artifactId>
+        <executions>
+          <execution>
+            <configuration>
+              <module>org.nuxeo.studio.StudioApp</module>
+            </configuration>
+          </execution>
+        </executions>
+      </plugin>
       <plugin>
         <groupId>org.apache.maven.plugins</groupId>
-        <artifactId>maven-antrun-plugin</artifactId>
-        <executions>
-          <execution>
-            <id>compile-js</id>
-            <phase>process-classes</phase>
-            <configuration>
-              <tasks>
-                <property name="compile_classpath"
-                  refid="maven.compile.classpath" />
-                <property name="runtime_classpath"
-                  refid="maven.runtime.classpath" />
-                <java failonerror="true" fork="true"
-                  classname="com.google.gwt.dev.Compiler">
-                  <classpath>
-                    <pathelement location="${project.build.outputDirectory}" />
-                    <pathelement path="${compile_classpath}" />
-                    <pathelement path="${runtime_classpath}" />
-                  </classpath>
-                  <jvmarg value="-Xmx256M" />
-                  <jvmarg value="${gwt.arg}" />
-                  <arg value="-war" />
-                  <arg value="${project.build.outputDirectory}/gwt-war" />
-                  <arg value="${gwt.module}" />
-                  <!-- useful for debug -->
-                  <!--
-                    <arg value="-style" />
-                    <arg value="PRETTY" />
-                  -->
-                  <!--
-                    <arg value="-logLevel" />
-                    <arg value="DEBUG" />
-                  -->
-                </java>
-              </tasks>
-            </configuration>
-            <goals>
-              <goal>run</goal>
-            </goals>
-          </execution>
-        </executions>
+        <artifactId>maven-jar-plugin</artifactId>
+        <configuration>
+          <excludes>
+            <exclude>**/.gwt-tmp/**</exclude>
+            <exclude>**/gwt-unitCache/**</exclude>
+          </excludes>
+        </configuration>
       </plugin>
     </plugins>
   </build>