diff --git i/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/OSGI-INF/layout-contrib.xml w/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/OSGI-INF/layout-contrib.xml
index eefd607..ca13f15 100644
--- i/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/OSGI-INF/layout-contrib.xml
+++ w/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/OSGI-INF/layout-contrib.xml
@@ -910,21 +910,23 @@
           <property name="required">false</property>
         </properties>
       </widget>
-      <widget name="mail.smtp.auth" type="checkbox">
+      <widget name="mail.smtp.auth" type="template">
+        <fields>
+          <field>['mail.smtp.auth']</field>
+        </fields>
         <labels>
           <label mode="any">label.setup.mail.smtp.auth</label>
         </labels>
         <translated>true</translated>
-        <fields>
-          <field>['mail.smtp.auth']</field>
-        </fields>
-        <properties mode="edit">
-          <property name="styleClass">dataInputText</property>
+        <properties mode="any">
+          <property name="template">
+            /incl/sysinfo/widgets/checkbox_template.xhtml
+          </property>
+          <property name="reRender">admin_setup_mail_ajaxPanel</property>
+          <property name="ajaxSingle">true</property>
         </properties>
-        <!-- Missing reRender property on checkbox widget -->
-        <!-- <properties mode="any"> -->
-        <!-- <property name="reRender">admin_setup_mail_ajaxPanel</property> -->
-        <!-- <property name="ajaxSingle">true</property> -->
+        <!-- <properties mode="edit"> -->
+        <!-- <property name="styleClass">dataInputText</property> -->
         <!-- </properties> -->
       </widget>
       <widget name="mail_smtp_auth_decorator" type="template">
@@ -933,16 +935,16 @@
             /incl/sysinfo/widgets/mail_smtp_auth_ajax_panel.xhtml
           </property>
           <property name="ajaxPanelId">admin_setup_mail_ajaxPanel</property>
-          <property name="rendered">#{true}</property>
-          <!-- <property name="rendered">#{value['mail.smtp.auth']==true}</property> -->
+          <!-- <property name="rendered">#{true}</property> -->
+          <property name="rendered">#{value['mail.smtp.auth']==true}</property>
         </properties>
         <subWidgets>
           <widget name="mail.smtp.username" type="text">
-            <!-- <widgetModes> -->
-            <!-- <mode value="any"> -->
-            <!-- #{value['mail.smtp.auth']!=true?'hidden':mode} -->
-            <!-- </mode> -->
-            <!-- </widgetModes> -->
+            <widgetModes>
+              <mode value="any">
+                #{value['mail.smtp.auth']!=true?'hidden':mode}
+              </mode>
+            </widgetModes>
             <labels>
               <label mode="any">label.setup.mail.smtp.username</label>
             </labels>
@@ -957,11 +959,11 @@
             </properties>
           </widget>
           <widget name="mail.smtp.password" type="secret">
-            <!-- <widgetModes> -->
-            <!-- <mode value="any"> -->
-            <!-- #{value['mail.smtp.auth']!=true?'hidden':mode} -->
-            <!-- </mode> -->
-            <!-- </widgetModes> -->
+            <widgetModes>
+              <mode value="any">
+                #{value['mail.smtp.auth']!=true?'hidden':mode}
+              </mode>
+            </widgetModes>
             <labels>
               <label mode="any">label.setup.mail.smtp.password</label>
             </labels>
diff --git i/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/web/nuxeo.war/incl/sysinfo/widgets/checkbox_template.xhtml w/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/web/nuxeo.war/incl/sysinfo/widgets/checkbox_template.xhtml
index e69de29..7bbbd56 100644
--- i/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/web/nuxeo.war/incl/sysinfo/widgets/checkbox_template.xhtml
+++ w/nuxeo-admin-center/nuxeo-admin-center/src/main/resources/web/nuxeo.war/incl/sysinfo/widgets/checkbox_template.xhtml
@@ -0,0 +1,20 @@
+<span xmlns:h="http://java.sun.com/jsf/html"
+  xmlns:c="http://java.sun.com/jstl/core"
+  xmlns:a4j="https://ajax4jsf.dev.java.net/ajax" id="#{widget.id}">
+
+  <c:if test="#{widget.mode != 'edit'}">#{field}</c:if>
+  <c:if test="#{widget.mode == 'edit'}">
+    <a4j:region id="#{widget.id}_region">
+
+      <a4j:support event="onchange" reRender="#{widgetProperty_reRender}"
+        immediate="#{widgetProperty_immediate}"
+        ajaxSingle="#{widgetProperty_ajaxSingle}" />
+
+      <h:selectBooleanCheckbox class="checkBox" value="#{field}"
+        immediate="true" />
+      <!-- onclick="this.form.submit();" -->
+
+    </a4j:region>
+  </c:if>
+
+</span>
\ No newline at end of file